#include "tep_incs.h"




//BOOL fnAttachTalk(TepDBConvData *pTepDBConvList, TepCurState *pGameState)
BOOL fnAttachTalk(TepDBConvData *pTepDBConvList, TepChar *pCharListRoot, TepConvData **ppGenericConvRoot )
{
	TepDBConvData	*pDBConvList = NULL;
	TepChar			*pCharList = NULL;


	/* scroll thru chars */
	for( pCharList = pCharListRoot; pCharList != NULL ; pCharList = pCharList->NEXT )
	{
//		printf("0!\n");
		/* scroll thru conv data */
		for( pDBConvList = pTepDBConvList ;pDBConvList != NULL ;pDBConvList = pDBConvList->NEXT )
		{
//			printf("1!\n");
			/* if this is the current characters dialogue then attach it */
			if(pCharList->id == pDBConvList->owner)
			{
//				printf("2!\n");
				/* try to attach it */
				if( fnTepConvDataAppend( &pCharList->conv, pDBConvList->id, pDBConvList->attachedto, pDBConvList->details) == FAILURE )
				{
					//printf("3!\n");
					printf("Could not allocate memory while attaching conversation data to a character.");
					return FALSE;
				}
				else
				{
//					printf("4!\n");
					/* it worked so make sure that the original list no longer has access to our string! */
					pDBConvList->details = NULL;
				}
			}
		}
	}

	/* NOW LETS FIND THE GENERIC CONV DATA!!! */
	for( pDBConvList = pTepDBConvList ;pDBConvList != NULL ;pDBConvList = pDBConvList->NEXT )
	{
//			printf("5!\n");
		if( pDBConvList->owner == (TEP_CHARACTER | CHAR_GEN))
		{

				/* try to attach it to the generic conversation list */
				if( fnTepConvDataAppend( ppGenericConvRoot, pDBConvList->id, pDBConvList->attachedto, pDBConvList->details) == FAILURE )
				{
					printf("Could not allocate memory while attaching conversation data to a character.");
					return FALSE;
				}
				else
				{
					/* it worked so make sure that the original list no longer has access to our string! */
					pDBConvList->details = NULL;
				}
		}
	}

	return TRUE;
}
