/* Program ID:          tep_main.h
 * Programmer Name:     Matt Phillips
 * Date Created:        January 24, 2001
 * Program Updated by:  Matt Phillips       Date of Update: 01/24/01
 * Program Description: tep_main.h is the header file for tep_main.c
 *                      lists function declarations
 * Dependencies:        N/A
 * Input Files:         N/A
 * Output Files:        N/A
 */

#define IPS_CHARACTER		"CharacterContent.txt"
#define IPS_CLUE			"ClueContent.txt"
#define IPS_COMMAND			"CommandContent.txt"
#define IPS_KEYWORDS		IPS_COMMAND
#define IPS_DEATH			"deathContent.txt"
#define IPS_TALK			"talkContent.txt"
#define IPS_CONVERSATION	IPS_TALK
#define IPS_ROOM			"roomInput.txt"
#define IPS_GENCONV			IPS_TALK


int     main( void );

BOOL    fnCheckTepFiles( void );
BOOL    fnInitPersistantStructs(TepCurState *pGameState);
BOOL	fnCreateKeywordList(TepCurState *pGameState);

void    fnTitleScreen( void );
char    fnGetInputChar( void );
BOOL    fnControl(char cCommand, TepCurState *pGameState);

BOOL fnInitLoad( TepCurState *pGameState );

BOOL    fnNewGame(TepCurState *pGameState);
BOOL    fnCharacterShuffle(TepCurState *pGameState);

BOOL	fnEndGame( TepCurState *pGameState );
BOOL    fnFreePersistantStructs(TepCurState *pGameState);

