#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <memory.h>
#include <string.h>
#include "CommandDefines.h"
#include "CharacterDefines.h"
#include "tep_types.h"

typedef struct _TepDBConvData
{
    TepID                   id;             /* conversation id */
    TepID                   attachedto;     /* ID of object attached to */
    TepID					owner;			/* ID of owner */
    pChar                   details;        /* null-termed string of its data */
    struct _TepDBConvData   *NEXT;          /* pointer to next ConvData */
} TepDBConvData, *pTepDBConvData;

/* protos */
TepID fnDefToHex(char *cpString);
BOOL fnEditChunker(char *cpString, FILE *FileHandle, char cTerminator);
BOOL fnTepEditUnNodeLink(TepIDUnNode **ppListRoot, FILE *FileHandle, char cComp);

/* added on Feb 25, 2001 by Jon Olson */
BOOL fnTepEditWriteFile(const DWORD dwType, void *pListRoot, FILE *outFile);


/* local defines */
#define SIZE_OF_ARRAY   80

