#include "tep_incs.h"

BOOL fnProtoNate (TepCurState *pGameState)
{
    int i, iStringLength;
    char *data[10], *data2[16];
    char localString[10][1000] =
    {
        {"Rushi"},//0
        {"##Rushi is large and fairly brutish in appearance. He has an excellent start on a beer belly, and doesnt appear to have bathed in weeks. His puffy eyes have the glaze of a habitual drunk, and his dark complexion is visibly flushed. He wears only a white loincloth, which looks stiff and soiled with neglect. Rushi moves unsteadily and with hesitation."},
        {"Totok"},  //2
        {"Totok is short and bulky. His giant muscles give him a rounded, lumpy appearance. Matted hair, a wild uni-brow, and a goofy, toothy grin frame Totok's bulging, confused eyes. His enormous arms end in wide, stumpy fingers, and his tree-trunk legs are supported by large, flat feet. On his broad back is a beautiful tattoo of a sea turtle. The fins end above his shoulders and down his legs, and the head wraps around his neck and down his chest like an elaborate necklace. Totok has a bad case of chronic dirtiness, so parts of the tattoo are often obscured. It looks as though Totok has worn the same dirty loin cloth for several years; it is too small for him, and is riding low in a lewd fashion."},
        {"Abandoned Longhouse"},  //4
        {"The soggy remains of this longhouse are a welcome home to the frogs that have taken it over. A large, broken boulder sprawls in the middle of the house; it appears to have somehow caused the gaping hole in the roof. This hole allows the heavy rain pummel the absent owners last possessions into the soft, muddy floor. As many as five families may have lived here once, but it is time for the jungle to reclaim this house."},
        {"Kiddie Longhouse"},  //6
        {"Inside the playhouse, multiple levels of \"forts\" and \"houses\" allow the children of Tep to play high above the floor. Every inch of the sturdy log frame is covered in colorful beads and painted images of a large, square jawed man laughing. Running down the center of the house, three fires warm and light the long room. At the far end of the playhouse, a sloppy pile of toys hint at the depressing truth of the villages devastation. This house was once full of children, but now is drearily empty."},
        {"Forest Path 1"},  //8
        {"#Massive fruit trees border either side of the path; all of them laden with large fruits. The path is covered with the fruit that has fallen from the trees; in the center of the path the fruits have been flattened by something heavy. A large beehive buzzes angrily several feet above your head. Discarded cutting tools lay beside rotting fruit."},
    };
    char localString2[16][1000] =
    {
        {"Frog"},
        {"The orange stripes on their backs say, \"BEWARE.\" They are cute though."},
        {"Boulder"}, //2
        {"The boulder is nearly as wide as the hut. Its amazing it was blasted so far!"},
        {"Possessions"}, //4
        {"Baskets, tools, clothing... everything is slowly sinking into the soft earth."},
        {"Forts/Houses"}, //6
        {"The small buildings are sturdily constructed of wood and painted with bright primary colors. Bridges and ladders connect the little structures to one another."},
        {"Fires"},//8
        {"These are small, stone encircled firepits, blackened with frequent use. Small fires are burning here."},
        {"Toys"},//10
        {"The toys include blocks, balls, dolls, and several simple musical instruments. Most of the dolls are forms of a square-jawed, muscular man or a serpentine, sinister man."},
        {"Tools"},//12
        {"The stone hatchet is notched from heavy use."},
        {"Beehive"},//14
        {"The beehive is made of wrapped layers of wax. Several bees buzz around the hive, seemingly unconcerned with life."},
    };

    pTepIDUnNode pLongD = NULL;
    pTepIDUnNode pForPath1 = NULL;
    pTepIDUnNode pForPath1Exits = NULL;
    pTepIDUnNode pKiddie = NULL;

    TepCmds HutCmds, ForestPath1, NullCmds;

    HutCmds.allCmd = 0;
    HutCmds.Look = 1;
    HutCmds.Leave = 1;
    HutCmds.Put = 1;
    HutCmds.Quit = 1;

    ForestPath1.allCmd = 0;
    ForestPath1.West = 1;
    ForestPath1.East = 0;
    ForestPath1.Look = 1;
    ForestPath1.Put = 1;
    ForestPath1.Quit = 1;
    ForestPath1.Go = 1;

    NullCmds.allCmd = 0;


    /* allocate and init all data strings */
    for (i = 0; i < 10; ++i)
    {
        iStringLength = strlen(localString[i]);
        data[i] = (char *)calloc( iStringLength + 1, sizeof(char) );
        strcpy(data[i], localString[i]);
        //printf(data[i]);
    }

    for (i = 0; i < 16; ++i)
    {
        iStringLength = strlen(localString2[i]);
        data2[i] = (char *)calloc( iStringLength + 1, sizeof(char) );
        strcpy(data2[i], localString2[i]);
        //printf(data2[i]);
    }

        /* declare Rushi */
    fnTepCharAppend( &(pGameState->liveList), TEP_CHARACTER | 1,
        (unsigned char *)data[0], (unsigned char *)data[1],
        NULL, NULL, NULL, NULL, 5, NULL, NULL, 0);

        /* declare totok */
    fnTepCharAppend( &(pGameState->liveList), TEP_CHARACTER | 2,
        (unsigned char *)data[2], (unsigned char *)data[3],
        NULL, NULL, NULL, NULL, 5, NULL, NULL, 0);

        /* Stuff in D */
    fnTepIDAppend(&pLongD, TEP_ROOM | 8);
    fnTepIDAppend(&pLongD, TEP_ROOM | 9);
    fnTepIDAppend(&pLongD, TEP_ROOM | 10);

        /* declare LongHouse D */
    fnTepRoomAppend(&(pGameState->FullMap), TEP_ROOM | 4, (unsigned char *)data[4],
                (unsigned char *)data[5], HutCmds, NULL, pLongD);


            /* Stuff in kiddie */
    fnTepIDAppend(&pKiddie, TEP_ROOM | 11);
    fnTepIDAppend(&pKiddie, TEP_ROOM | 12);
    fnTepIDAppend(&pKiddie, TEP_ROOM | 13);

        /* declare LongHouse kiddie */
    fnTepRoomAppend(&(pGameState->FullMap), TEP_ROOM | 5, (unsigned char *)data[6],
                (unsigned char *)data[7], HutCmds, NULL, pKiddie);


            /* Stuff in forest 1 */
    fnTepIDAppend(&pForPath1, TEP_ROOM | 11);
    fnTepIDAppend(&pForPath1, TEP_ROOM | 12);


    /* NESW connections from Forrest Path 1 */
    fnTepIDAppend(&pForPath1Exits, 0);
    fnTepIDAppend(&pForPath1Exits, 0);
    fnTepIDAppend(&pForPath1Exits, 0);
    fnTepIDAppend(&pForPath1Exits, TEP_ROOM | 1);

        /* declare forest 1 */
    fnTepRoomAppend(&(pGameState->FullMap), TEP_ROOM | 7, (unsigned char *)data[8],
                (unsigned char *)data[9], HutCmds, pForPath1Exits, pForPath1);

/************ Items in locations **************/
        /* declare frog */
    fnTepRoomAppend(&(pGameState->FullMap), TEP_ROOM | 8, (unsigned char *)data2[0],
                (unsigned char *)data2[1], NullCmds, NULL, NULL);

        /* declare boulder */
    fnTepRoomAppend(&(pGameState->FullMap), TEP_ROOM | 9, (unsigned char *)data2[2],
                (unsigned char *)data2[3], NullCmds, NULL, NULL);

            /* declare possesions */
    fnTepRoomAppend(&(pGameState->FullMap), TEP_ROOM | 10, (unsigned char *)data2[4],
                (unsigned char *)data2[5], NullCmds, NULL, NULL);

            /* declare Forts/houses */
    fnTepRoomAppend(&(pGameState->FullMap), TEP_ROOM | 11, (unsigned char *)data2[6],
                (unsigned char *)data2[7], NullCmds, NULL, NULL);

            /* declare fires */
    fnTepRoomAppend(&(pGameState->FullMap), TEP_ROOM | 12, (unsigned char *)data2[8],
                (unsigned char *)data2[9], NullCmds, NULL, NULL);

            /* declare toys */
    fnTepRoomAppend(&(pGameState->FullMap), TEP_ROOM | 13, (unsigned char *)data2[10],
                (unsigned char *)data2[11], NullCmds, NULL, NULL);

            /* declare tools */
    fnTepRoomAppend(&(pGameState->FullMap), TEP_ROOM | 14, (unsigned char *)data2[12],
                (unsigned char *)data2[13], NullCmds, NULL, NULL);

            /* declare beehive */
    fnTepRoomAppend(&(pGameState->FullMap), TEP_ROOM | 15, (unsigned char *)data2[14],
                (unsigned char *)data2[15], NullCmds, NULL, NULL);





    return TRUE;
}



BOOL fnProtoFrost (TepCurState *pGameState)
{
    int i, iStringLength;

    char *data[40];
/*  Data includes:

    char *pAlaquaName;
    char *pAlaquaDesc;
    char *pVillage1Name;
    char *pVillage1Desc;
    char *pLongAName;
    char *pLongADesc;
    char *pLongCName;
    char *pLongCDesc;
    char *pFieldName;
    char *pFieldDesc;
*/

    char localString[40][1000] =
    {
        {"Alaqua"},
        {"Alaqua is an elegant, slender woman of moderate height.  She wears a deep blue cotton robe tied at the waist with rope, and although her ebony complexion shows a few signs of age, she retains a comely form.  A small leather pouch dangles on her left hip.  Her long, black hair is pulled back into a thick braid that snakes down her left shoulder.  High cheekbones and arching eyebrows lend her a somewhat severe countenance, and her striking, blue eyes regard you frostily."},

        {"Village 1"},
        {"#In this end of the village, two abandoned longhouses provide a stark contrast to the lively atmosphere of what seems to be a children's playhouse and an occupied longhouse. Nearest the forest is a ruined shell of a wooden longhouse. South of this is a colorfully painted longhouse. On the west side is another old longhouse which is marked by two broken sculptures on either side of its doorway. The grass walls are lightly covered with a sickly, black mold. In the center of these buildings is the least dilapidated of the abandoned houses(C). It appears to have an occupant. ##To the north lies a jagged path up the volcano. #To the east, a path disappears into the forest. #To the south, an open field lies beyond the children's playhouse. #To the west, the village continues around the volcano."},

        {"Abandoned Longhouse A"},
        {"The front half of this house is lined with wooden tables covered in chipped stones and stone carving tools. The floor is covered in a layer of gray dust. A half-finished sculpture, resembling a horrific aquatic beast, lies on its side a few paces from the doorway. Somebody went to great lengths to completely destroy the head. The back of the house is filled with uninteresting items of everyday life on Tep. Anything of value has long since been looted. ##The only exit leads back to the village."},

        {"Longhouse C"},
        {"This longhouse's only inhabitant has piles of clothes and jewelry near the front of the house. Aside from a bed and a table, the house is covered in a gentle blanket of dust. Straw mats are hung across the house so it appears to be much smaller. A small fire pit provides the longhouse's only light and causes feathered shadows to dance silently on the walls. ##The only exit leads back to the village."},

        {"Field"},
        {"#Waist high grasses sway gently in the wind. Paths cut by playful children criss-cross the landscape and the field is clear of harmful plants and rocks. These features make it the perfect place for carefree youngsters. A forgotten toy and a string of beads lie in the sweeping grass. ##To the north shoddy buildings mark the beginning of the village. #To the east a wooden fence circles playground. #To both the west and south two rocky paths lead to the cliffs on the horizon."},

        {"Sculptures"},
        {"The smashed remains resemble people."},

        {"Mold"},
        {"The mold has large fuzzy spots in full bloom. Ingesting it would probably not be a good idea."},

        {"Tools"},
        {"The tools are old and worn. They need to be replaced."},

        {"Tables"},
        {"The tables have suffered heavy use. A thin, gray powder highlights the cracks and dents."},

        {"Dust"},
        {"This dust looks like it would stick to anything."},

        {"Beast Sculpture"},
        {"This hideous beast looks like a cross between a man and several sea animals."},

        {"Stones"},
        {"Some of these stone pieces are jagged and sharp."},

        {"Clothes and Jewelry"},
        {"There are far too many outfits and accoutrements for one person to wear..."},

        {"Bed"},
        {"This is probably the most padded bed on Tep."},

        {"Table"},
        {"The wooden table has dried food and liquid stains on it.  It is rather disgusting."},

        {"Dust"},
        {"The lonely dust of disuse covers the majority of the longhouse."},

        {"Mats"},
        {"These mats make a pathetic wall."},

        {"Fire"},
        {"Gray ashes are piled up in the fireplace.  A small fire is burning here."},

        {"Toy"},
        {"A carved wooden image of an iguana lays forgotten to the side of the field. It's poorly painted in a pale blue, and has only three legs."},

        {"String of Beads"},
        {"Laying half underneath the toy three-legged iguana is a string of beads. The beads are ceramic and painted pale yellow."},
    };

    TepCmds LhouseCommands, FieldCommands, Village1Commands, NullCmds;

    pTepIDUnNode pIdList1 = NULL;
    pTepIDUnNode pIdList2 = NULL;

    LhouseCommands.allCmd = 0;
    LhouseCommands.Look = 1;
    LhouseCommands.Put = 1;
    LhouseCommands.Quit = 1;
    LhouseCommands.Leave = 1;

    FieldCommands.allCmd = 0;
    FieldCommands.North = 1;
    FieldCommands.Look = 1;
    FieldCommands.Go = 1;
    FieldCommands.Quit = 1;

    Village1Commands.allCmd = 0;
    Village1Commands.South = 1;
    Village1Commands.East = 1;
    Village1Commands.Look = 1;
    Village1Commands.Go = 1;
    Village1Commands.Quit = 1;

    NullCmds.allCmd = 0;

    for (i = 0; i < 40; ++i)
    {
        iStringLength = strlen(localString[i]);
        data[i] = (char *)calloc( iStringLength + 1, sizeof(char) );
        strcpy(data[i], localString[i]);
    }

    fnTepCharAppend( &(pGameState->liveList), TEP_CHARACTER | 3, (unsigned char *)data[0], (unsigned char *)data[1], NULL, NULL, NULL, NULL, 5, NULL, NULL, 0);

    /* NESW connections from Village 1 */
    fnTepIDAppend(&pIdList1, 0);
    fnTepIDAppend(&pIdList1, TEP_ROOM | 7);
    fnTepIDAppend(&pIdList1, TEP_ROOM | 6);
    fnTepIDAppend(&pIdList1, 0);

    /* objects in Village 1 */
    fnTepIDAppend(&pIdList2, TEP_ROOM | 16);
    fnTepIDAppend(&pIdList2, TEP_ROOM | 17);
	fnTepIDAppend(&pIdList2, TEP_ROOM | 5);

    /* Village 1 */
    fnTepRoomAppend( &(pGameState->FullMap),
                    TEP_ROOM | 1,
                    data[2],
                    data[3],
                    Village1Commands,
                    pIdList1,
                    pIdList2);

    /* attatch Rushi to Village 1 */
    pIdList1 = NULL;
    fnTepIDAppend(&pIdList1, TEP_CHARACTER | 1);
    fnTepDynRoomAppend( &(pGameState->mapLite), TEP_ROOM | 1, NULL, pIdList1, NULL);

    pIdList1 = NULL;
    pIdList2 = NULL;

    /* objects in Abandoned Longhouse A */
    fnTepIDAppend(&pIdList2, TEP_ROOM | 18);
    fnTepIDAppend(&pIdList2, TEP_ROOM | 19);
    fnTepIDAppend(&pIdList2, TEP_ROOM | 20);
    fnTepIDAppend(&pIdList2, TEP_ROOM | 21);
    fnTepIDAppend(&pIdList2, TEP_ROOM | 22);

    /* Abandoned Longhouse A */
    fnTepRoomAppend( &(pGameState->FullMap),
                    TEP_ROOM | 2,
                    data[4],
                    data[5],
                    LhouseCommands,
                    NULL,
                    pIdList2);

    pIdList1 = NULL;
    pIdList2 = NULL;

    /* objects in Longhouse C */
    fnTepIDAppend(&pIdList2, TEP_ROOM | 23);
    fnTepIDAppend(&pIdList2, TEP_ROOM | 24);
    fnTepIDAppend(&pIdList2, TEP_ROOM | 25);
    fnTepIDAppend(&pIdList2, TEP_ROOM | 26);
    fnTepIDAppend(&pIdList2, TEP_ROOM | 27);
    fnTepIDAppend(&pIdList2, TEP_ROOM | 28);

    /* Longhouse C */
    fnTepRoomAppend( &(pGameState->FullMap),
                    TEP_ROOM | 3,
                    data[6],
                    data[7],
                    LhouseCommands,
                    NULL,
                    pIdList2);

    pIdList1 = NULL;
    pIdList2 = NULL;

    /* NESW connections from Field */
    fnTepIDAppend(&pIdList1, TEP_ROOM | 1);
    fnTepIDAppend(&pIdList1, 0);
    fnTepIDAppend(&pIdList1, 0);
    fnTepIDAppend(&pIdList1, 0);

    /* objects in Field */
    fnTepIDAppend(&pIdList2, TEP_ROOM | 29);
    fnTepIDAppend(&pIdList2, TEP_ROOM | 30);

    /* Field */
    fnTepRoomAppend( &(pGameState->FullMap),
                    TEP_ROOM | 6,
                    data[8],
                    data[9],
                    FieldCommands,
                    pIdList1,
                    pIdList2);


    /* other objects */
    fnTepRoomAppend(&(pGameState->FullMap), TEP_ROOM | 16, data[10], data[11], NullCmds, NULL, NULL);
    fnTepRoomAppend(&(pGameState->FullMap), TEP_ROOM | 17, data[12], data[13], NullCmds, NULL, NULL);
    fnTepRoomAppend(&(pGameState->FullMap), TEP_ROOM | 18, data[14], data[15], NullCmds, NULL, NULL);
    fnTepRoomAppend(&(pGameState->FullMap), TEP_ROOM | 19, data[16], data[17], NullCmds, NULL, NULL);
    fnTepRoomAppend(&(pGameState->FullMap), TEP_ROOM | 20, data[18], data[19], NullCmds, NULL, NULL);
    fnTepRoomAppend(&(pGameState->FullMap), TEP_ROOM | 21, data[20], data[21], NullCmds, NULL, NULL);
    fnTepRoomAppend(&(pGameState->FullMap), TEP_ROOM | 22, data[22], data[23], NullCmds, NULL, NULL);
    fnTepRoomAppend(&(pGameState->FullMap), TEP_ROOM | 23, data[24], data[25], NullCmds, NULL, NULL);
    fnTepRoomAppend(&(pGameState->FullMap), TEP_ROOM | 24, data[26], data[27], NullCmds, NULL, NULL);
    fnTepRoomAppend(&(pGameState->FullMap), TEP_ROOM | 25, data[28], data[29], NullCmds, NULL, NULL);
    fnTepRoomAppend(&(pGameState->FullMap), TEP_ROOM | 26, data[30], data[31], NullCmds, NULL, NULL);
    fnTepRoomAppend(&(pGameState->FullMap), TEP_ROOM | 27, data[32], data[33], NullCmds, NULL, NULL);
    fnTepRoomAppend(&(pGameState->FullMap), TEP_ROOM | 28, data[34], data[35], NullCmds, NULL, NULL);
    fnTepRoomAppend(&(pGameState->FullMap), TEP_ROOM | 29, data[36], data[37], NullCmds, NULL, NULL);
    fnTepRoomAppend(&(pGameState->FullMap), TEP_ROOM | 30, data[38], data[39], NullCmds, NULL, NULL);


    return TRUE;

}


BOOL fnProtoCleanup (TepCurState *pGameState)
{
    /* delete the entire char list */
    fnTepCharDelete(&(pGameState->liveList), NULL);

    /* delete the dynMap */
    fnTepDynRoomDelete(&(pGameState->mapLite), NULL);

    return TRUE;
}



BOOL    fnProtoCreateKeywordList(TepCurState *pGameState)
{
    TepRoom *pNode;
    pChar pKeyword = NULL;
    int i, iWordLength;

    /* CHONKY ARRAY FOR COMMAND WORDS */
    char *commands[10];
    char localString[9][15] =
    {
        {"NORTH"},//0
        {"SOUTH"},
        {"EAST"},
        {"WEST"},
        {"LOOK"},
        {"LEAVE"},
        {"PUT"},
        {"GO"},
        {"QUIT"},
    };


    for (i = 0; i < 9; ++i)
    {
        iWordLength = strlen(localString[i]);
        commands[i] = (pChar)malloc( (iWordLength + 1) * sizeof(char) );
        strcpy(commands[i], localString[i]);
    }

    fnTepDataStringAppend(&(pGameState->keywords), COM_NORTH , commands[0]);
    fnTepDataStringAppend(&(pGameState->keywords), COM_SOUTH , commands[1]);
    fnTepDataStringAppend(&(pGameState->keywords), COM_EAST , commands[2]);
    fnTepDataStringAppend(&(pGameState->keywords), COM_WEST , commands[3]);
    fnTepDataStringAppend(&(pGameState->keywords), COM_LOOK , commands[4]);
    fnTepDataStringAppend(&(pGameState->keywords), COM_LEAVE , commands[5]);
    fnTepDataStringAppend(&(pGameState->keywords), COM_PUT , commands[6]);
    fnTepDataStringAppend(&(pGameState->keywords), COM_GO , commands[7]);
    fnTepDataStringAppend(&(pGameState->keywords), COM_QUIT , commands[8]);



    pNode = pGameState->FullMap;

    while(pNode != NULL)
    {
        /* allocate memory for the new word */
        iWordLength = strlen(pNode->name);
        pKeyword = (pChar)malloc( (iWordLength + 1) * sizeof(char) );

        /* if allocation fials, fail */
        if(pKeyword == NULL)
        {
            return FAILURE;
        }

        /* once the new mem is allocated copy the word into it */
        strcpy(pKeyword, pNode->name);

        /* make the keyword uppercase */
        for(i = 0; i < iWordLength; i++)
        {
            pKeyword[i] = toupper(pKeyword[i]);
        }

        //printf(": %s", pKeyword);

        /* add the word and ID to the keyword list */
        fnTepDataStringAppend(&(pGameState->keywords), pNode->id , pKeyword);
        //free(pKeyword);

        /* re-init pKeyword */
        pKeyword = NULL;

        /* increment pNode */
        pNode = pNode->NEXT;
    }

    return TRUE;
}