#define PAUSE 666
#define NOPAUSE 665
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <stdarg.h>
#include <string.h>

int fnPrintOut(int fPause, char *clue, char *character, int in_values, ...);

int main()
{

	char pText1[99999];
	char pText2[99999];
	char pText3[99999];
	char pText4[99999];

	strcpy(pText1, "#The Emissary of Tep @ enables the player to explore a detailed tropical island, make conversation with the natives, and, by collecting pertinent evidence, guide the islanders in their sacrificial rites, thereby ending a deadly supernatural battle.  #At the start of each day, the evil followers of Rametep kill a villager.  The character then has all day to collect evidence against the perpetrators, and persuade the good villagers to sacrifice one of their evil brethren at the nightly meeting (for the followers of Rametep will do their best to trick the good villagers into sacrificing one of their own).  The player must successfully accomplish two goals in order to defeat the game: 1) Determine which four of the twenty-one villagers has sided with the evil God Rametep.  This is accomplished by collecting incriminating evidence and making astute observations.  2)Persuade the good villagers to throw their errant brethren, one by one, into the volcano, thereby delivering the island of Tep from the clutches of Rametep.");
	strcpy(pText2, "This is accomplished by conversing with the villagers. The player is able to move about the island, examine objects in the environment, and make friendly or hostile gestures toward the natives via a text parser action interface (see User Interface for more details).  Collecting and filing evidence against characters is initiated from this prompt.  The menu based help file can also be executed from this prompt; this feature explains the game mechanics to the player. When in the same location as a villager, the player is able to initiate conversation from the action parser.  Utilizing the conversation text parser, the player may show evidence he or she has collected to the villager in order to sway his or her opinion, as well as enact more miscellaneous conversation.  Once the conversation ends, control is returned to the action parser.  At each village meeting, every villager votes to sacrifice the villager they are most suspicious of.  The votes are tallied, and the chosen villager is cast into the volcanof");
	strcpy(pText3, "skjfafjafjd  jfjfjjdfk ;fjkfjkfjkfj fjkfjkjfkhgja agj");
	strcpy(pText4, "Test.*  The character @ loves his clue, *.");

	fnPrintOut(PAUSE, "Totok's severed head", "Totok", 4, pText1, pText2, pText3, pText4);

	printf("\n");

	return 0;	

}

/*  FUNCTION:		fnPrintOut
	PARAMETERS:		fPause,						Passing NOPAUSE will cause fnPrintOut to return as soon as all of its
												arguments have been formatted and printed to screen.  Passing PAUSE
												will cause fnPrintOut to pause the game after all of its arguments have
												been formatted and printed to screen; it will not return until the user
												has whacked any key.

					clue						Pass a string that is the name of a clue; this string will replace any
												occurrence of '*' characters in the varargs.  Pass NULL to ignore this formatting.

					character					Pass a string that is the name of a character; this string will replace any
												occurrence of '@' characters in the varargs.  Pass NULL to ignore this formatting.

					in_values,					Pass the number of subsequent char * arguments.
	
					...							n number of char * arguments (varargs), each of which will be formatted and 
												printed to screen, in the order they are passed.

	RETURN VALUE:	0 (failure), or 1 (success)	
	SIDE EFFECTS:	See fPause.
	DESCRIPTION:	Takes a variable number of char *s and prints them to the screen verbatim, in the order that they
					are passed.  fnPrintOut formats text in the following manner:
					1) Makes sure no words near the right hand side of the screen are "cut in half".
					2) Makes sure that if more than one full screenful of text is to be printed at once, text printing
					stops at each screenful.  Printing resumes once the player strikes any key.
					3) Each '#' that is encountered is replaced with a paragraph indentation, i.e. a '\n' character
					followed by four adjacent ' ' characters.  Each '*' that is encountered is replaced with the clue 
					string.  Each '@' that is encountered is replaced with the character string.  
					See fPause for additional behaviour.  NOTE: Each special character ('#', '*', '@') requires a ' '
					character to precede it (i.e. "All your base are belong to us.#."  won't work.  
					But " #How are you gentlemen!!!" will function correctly).  
 */

int fnPrintOut(int fPause, char *clue, char *character, int in_values, ...)
{
	int iChars = 0;				/* Counts the number of characters in a line. */
	int iLines = 0;				/* Counts the number of lines on the screen in one call to fnPrintOut. */
	int i = 0;					/* The index into the current string. */
	int n = 0;					/* A generic counter. */
	char cTempBuff[90] = {'~'};	/* The temporary memory buffer where each "chunk" of text is stored; it is terminated */
								/* with a '~' character and should never contain any ' ' characters. */

	va_list marker;				/* Marks the first of the variable arguments. */
	char *arg;					/* Contains the current argument.  */
	int count = 0;				/* A counter that keeps track of the number of variable arguments that have been */
								/* processed. */

	/* If fPause was passed unmeaningful values... */
	if ( (fPause != PAUSE) && (fPause != NOPAUSE) )
	{
		/* Then complain about it and return 0 for failure. */
		printf("fnPrintOut is complaining that fPause, it's first argument, was passed unmeaningful values!\n");
		return 0;
	}

	va_start(marker, in_values);		/* Begin using variable arguments. */
	arg = va_arg(marker, char *);		/* Initialize arg with the first variable argument. */

	/* Process every variable argument.  After an argument has been processed, intialize arg with the next */
	/* variable argument; also set i to 0 so that it corresponds to the first character of the new variable argument. */
	for (; count < in_values; arg = va_arg(marker, char *), ++count, i = 0)
	{

		/* Until the terminating NULL is reached in the string... */
		while (*(arg + i) != 0)
		{
			/* If a '#' character is reached... */
			if (*(arg + i) == '#')
			{
				++i;					/* Advance to the next character in the argument (without printing the '#') */
				printf("\n    ");		/* Print a paragraph indentation */
				iChars = 4;				/* Update iChars to reflect that we are now 4 spaces into the line. */
				++iLines;				/* Update the iLines to reflect that we are now one line down from before. */
				continue;				/* and return to the top of the loop to test if we have hit the NULL yet. */
			} /* end if */

			/* Place every character (save '#', ' ', '~' and NULL) in the string, one after another, into the temporary 
			buffer. */
			for (n = 0; *(arg + i) != ' ' && *(arg + i) != 0; ++n, ++i)
			{
				/* Check for the '*' special character; if one is encountered, deal with it accordingly. */
				if (*(arg + i) == '*')
				{
					int iSpecialCount;	/* A generic counter */

					++i;				/* Advance to the next character in the argument (without printing the '*') */
					for (iSpecialCount = 0; iSpecialCount < (int)strlen(clue); ++iSpecialCount, ++n)
					{
						cTempBuff[n] = *(clue + iSpecialCount);		/* "Inject" the clue name into the text output (using the */
																	/* temporary buffer as the vector) character by character. */
					}/* end for loop */

				}/* end if */

				/* Check for the '@' special character; if one is encountered, deal with it accordingly. */
				if (*(arg + i) == '@')
				{
					int iSpecialCount;	/* A generic counter */

					++i;				/* Advance to the next character in the argument (without printing the '@') */
					for (iSpecialCount = 0; iSpecialCount < (int)strlen(character); ++iSpecialCount, ++n)
					{
						cTempBuff[n] = *(character + iSpecialCount);/* "Inject" the clue name into the text output (using the */
																	/* temporary buffer as the vector) character by character. */
					}/* end for loop */

				}/* end if */

				cTempBuff[n] = *(arg + i);
				cTempBuff[n + 1] = '~';				/* A delimiting '~' will always terminate the temporary buffer */
	
				/* If the number of characters in the temporary buffer exceeds the number of remaining characters */
				/* on the line... */
				if (n > (76 - iChars) )
				{
					printf("\n");	/* Jump down to the next line... */
					++iLines;		/* Increment iLines to keep track of the number of lines remaining onscreen. */
					iChars = 0;		/* Reset the number of remaining characters on this line to zero */
				} /* end if */

				/* If the number of lines onscreen in one fnPrintOut exceeds 21... */
				if (iLines > 21)
				{					
					while(!_kbhit())					/* Pause the game until the player whacks any key. */						
					{
						;
					} /* end while loop */							
					_getch();							/* Throw away the character the player entered when */
														/* he or she whacked said any key. */

					iLines = 0;							/* Reset iLines to zero, as we are now on a fresh screen. */
				} /* end if */
			} /* end for loop */

			/* If the current character is a ' ' or a NULL... */
			if (*(arg + i) == ' ' || *(arg + i) == 0)
			{	
				/* Until the terminating '~' character is reached... */
				for (n = 0; cTempBuff[n] != '~'; ++n, ++iChars)
				{
					printf("%c", cTempBuff[n]);			/* Print every character in the temporary buffer.  For each */
														/* character printed, increment iChars, to keep track of how */
														/* much space remains on the line. */
				} /* end for loop */

				cTempBuff[0] = '~';	/* Make sure the '~' character is present to denote that there is nothing to print */
									/* in the temporary buffer anymore. */

				/* If the current character is indeed a ' ' and not a NULL... */
				if (*(arg + i) == ' ')
				{
					++iChars;			/* Increment iChars once, for the ' ' character. */
					++i;				/* Increment to the next character in the string. */
					printf(" ");		/* and finally print the ' '. */
				} /* end if */
			} /* end if */
		} /* end while loop */

	} /* end for loop */
	
	va_end (marker);					/* We are finished using varargs. */

	if (fPause == PAUSE)
	{
					
		while(!_kbhit())								/* Pause the game until the player whacks any key. */				
		{
			;
		} /* end while loop */								
		_getch();										/* Throw away the character the player entered when */
														/* he or she whacked any key. */
	} /* end if */

	return 1;

}