#include "tep_incs.h"

/* Function Name: Quit
 * Programmer Name: Dan Davis-Boxleitner
 * Date Created: February 10th, 2001
 * Program Updated by:
 *
 * Program Description:		This program calls an input function which prompts
 *							the user to quit the game. If the input is
 *							a 'Y', this function returns true. If the input
 *							is a 'N', this function returns false.
 * Program dependencies:	"Quit.h".fnGetInputChar(),
 *
 * Takes:					Nothing
 *
 * Gives:					A boolean value,
 *							TRUE means the player wants to quit
 *							FALSE means the player doesn't want to quit
 *
 */
BOOL fnQuit( void )
{
	char cChoice;

	cChoice = fnGetInputChar();

	if( cChoice == 'Y' )
		return TRUE;
	else
		return FALSE;
}