/*FUNCTION:         fnShowResponseSearch
 *PARAMETERS:       TepConvData *pListRoot      pointer to the start of a character's list
 *RETURN VALUES:    pointer the the node that matches the search
 *SIDE EFFECTS:     none
 *DESCRIPTION:  This funciton searches through a characters data to find the proper response
 *              to being shown evidence.
*/
TepConvData * fnShowReponseSearch(TepConvData *pListRoot, TepID bitMask);

/*FUNCTION:         fnShow
 *PARAMETERS:       TepCurState *State  pointer to the current game state
 *RETURN VALUES:    SUCCESS or FAILURE
 *SIDE EFFECTS:     Adjusts the current characters whack value
 *                  Prints a response to the screen
 *DESCRIPTION:  This function is used to show a character evidence. It runs through
 *              a calculation based on the character's trust factor towards the player,
 *              the character's suspiscion index and the number of true and false clues
 *              shown to the character and adjusts the characters suspicion index accordingly.
*/
BOOL fnShow(TepCurState *State, TepParse msg);
